/*
 *
 * Copyright (C) 2005 SWsoft
 *  All rights reserved.
 *
 */

#ifndef __OOPS_H__
#define __OOPS_H__

struct oops_jumpbuf {
	unsigned long retaddr;
	unsigned long esp, ebp;
	struct oops_jumpbuf *prev;
	void *data[3];
};

static int inline oops_set_jump(struct oops_jumpbuf *jumpbuf)
{
	int ret, tmp;

	jumpbuf->prev = current->oops_jumpbuf;
	current->oops_jumpbuf = jumpbuf;

	__asm__ __volatile__(
			"movl $1f, (%3)\n\t"
			"movl %%esp, 4(%3)\n\t"
			"movl %%ebp, 8(%3)\n\t"
			"1:\n\t"
			: "=&a" (ret), "=&d" (tmp)
			: "0" (0), "1" (jumpbuf)
			: "cc", "ebx", "ecx", "esi", "edi", "memory");
	return ret;
}

static void inline oops_do_jump(void)
{
	struct task_struct *tsk;
	struct oops_jumpbuf *jumpbuf;

	tsk = current;
	jumpbuf = tsk->oops_jumpbuf;
	if (jumpbuf == NULL)
		return;
	if (in_irq())
		return;

	tsk->oops_jumpbuf = jumpbuf->prev;	/* = oops_reset_jump */
	__asm__ __volatile__ (
			"movl 8(%0), %%ebp\n\t"
			"movl 4(%0), %%esp\n\t"
			"movl $1, %%eax\n\t"
			"jmp *(%0)\n\t"
			:
			: "d" (jumpbuf));
}

static void inline oops_reset_jump(struct oops_jumpbuf *jumpbuf)
{
	current->oops_jumpbuf = jumpbuf->prev;
}

#endif /* __OOPS_H__ */
