/*
 *  include/linux/ve_proto.h
 *
 *  Copyright (C) 2005  SWsoft
 *  All rights reserved.
 *
 */

#ifndef __VE_OWNER_H__
#define __VE_OWNER_H__

#include <linux/config.h>
#include <linux/vmalloc.h>

extern char _end[];
#define VE_ADDR_STATIC(x) ((unsigned long)(x) < (unsigned long)&_end)
#define VE_ADDR_MODULE(x) ({						\
	unsigned long __addr;						\
									\
	__addr = (unsigned long)(x);					\
	VE_ADDR_STATIC(__addr) ||					\
		(__addr >= VMALLOC_START && __addr < VMALLOC_END);	\
})

#define DCL_VE_OWNER(name, kind, type, member, attr1, attr2)
	/* prototype declares static inline functions */

#define DCL_VE_OWNER_PROTO(name, kind, type, member, attr1, attr2)	\
type;									\
static inline struct ve_struct *VE_OWNER_##name(type *obj)		\
{									\
	return obj->member;						\
}									\
static inline void SET_VE_OWNER_##name(type *obj, struct ve_struct *ve)	\
{									\
	obj->member = ve;						\
}

#endif /* __VE_OWNER_H__ */
